/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * PodRS232Panel.java
 *
 * Created on 29-oct-2011, 0:20:06
 */
package rs232;
/**
 *
 * @author Jorge
 */
import java.awt.Graphics;
import java.awt.Color;

public class PodRS232Panel extends javax.swing.JPanel {
    private static int DISTANCIA_ENTRE_PINES=40;
    private static int DISTANCIA_NUMERO_A_PIN=20;
    private static int ANCHO_PIN=10;
    public static boolean CONECTANDO=true;
    public static boolean DESCONECTANDO=false;
    
    private int xConectores[]=new int[2];
    private int yConectores[]=new int[2];
    private int pinSeleccionadoEnConector0=-1;
    private int pinSeleccionadoEnConector1=-1;
    
    public int[] conexiones0=new int[25];
    public int[] conexiones1=new int[25]; 
    public int maxConexion=0;
    public int pulsadoEn1=-1;
    public int pulsadoEn0=-1;
    
    
    public boolean modo=CONECTANDO;
    
    /** Creates new form PodRS232Panel */
    public PodRS232Panel() {
        initComponents();
        inicializar();
    }
    
    public void inicializar(){
        
        for(int i=0;i<25;i++){
            conexiones0[i]=-1;
            conexiones1[i]=-1;
        }
    }
    
   

    public void paintComponent(Graphics g){
        super.paintComponent(g);
        int x0,y0,x1,y1;
        dibujarConector(g,50,50,0);
        dibujarConector(g,350,50,1);
        for(int i=0;i<maxConexion;i++){
                x0=getXPin(0,conexiones0[i])+ANCHO_PIN/2;
                y0=getYPin(0,conexiones0[i])+ANCHO_PIN/2;
                x1=getXPin(1,conexiones1[i])+ANCHO_PIN/2;
                y1=getYPin(1,conexiones1[i])+ANCHO_PIN/2;
                g.setColor(Color.red);
                g.drawLine(x0, y0, x1, y1);
        }
    }
    
    /*public boolean bienConectado(){
        boolean existe023=false;
        boolean existe123=false;
        boolean existe045=false;
        boolean existe145=false;
        boolean existe077=false;
        boolean existe068=false;
        boolean existe0620=false;
        boolean existe168=false;
        boolean existe1620=false;
        for(int i=0;i<maxConexion;i++){
            existe023=existe023 || (conexiones0[i]==1 && conexiones1[i]==2);
            existe123=existe123 || (conexiones1[i]==1 && conexiones0[i]==2);
            existe045=existe045 || (conexiones0[i]==3 && conexiones1[i]==4);
            existe145=existe145 || (conexiones1[i]==3 && conexiones0[i]==4);
            existe077=existe077 || (conexiones0[i]==6 && conexiones1[i]==6);
            existe068=existe068 || (conexiones0[i]==5 && conexiones1[i]==7);
            existe0620=existe0620 || (conexiones0[i]==5 && conexiones1[i]==19);
            existe168=existe168 || (conexiones1[i]==5 && conexiones0[i]==7);
            existe1620=existe1620 || (conexiones1[i]==5 && conexiones0[i]==19);
        }
        return existe023 && existe123 && existe045 && existe145 && existe077 && existe068 && existe0620 && existe168 && existe1620;
    }
    */
    
    public  boolean bienConectado(int uart,boolean ctrl_flujo){
        boolean b=false;
        if(ctrl_flujo==false){
            boolean existe023=false;
            boolean existe123=false;
            boolean existe045=false;
            boolean existe145=false;
            boolean existe077=false;
            boolean existe068=false;
            boolean existe0620=false;
            boolean existe168=false;
            boolean existe1620=false;
            for(int i=0;i<maxConexion;i++){
                existe023=existe023 || (conexiones0[i]==1 && conexiones1[i]==2);
                existe123=existe123 || (conexiones1[i]==1 && conexiones0[i]==2);
                existe045=existe045 || (conexiones0[i]==3 && conexiones1[i]==4);
                existe145=existe145 || (conexiones1[i]==3 && conexiones0[i]==4);
                existe077=existe077 || (conexiones0[i]==6 && conexiones1[i]==6);
                existe068=existe068 || (conexiones0[i]==5 && conexiones1[i]==7);
                existe0620=existe0620 || (conexiones0[i]==5 && conexiones1[i]==19);
                existe168=existe168 || (conexiones1[i]==5 && conexiones0[i]==7);
                existe1620=existe1620 || (conexiones1[i]==5 && conexiones0[i]==19);
            }
            b=existe023 && existe123 && existe045 && existe145 && existe077 && existe068 && existe0620 && existe168 && existe1620;
        }
        else{
            boolean existe023=false;
            boolean existe123=false;
            boolean existe045=false;
            boolean existe145=false;
            boolean existe077=false;
      
            for(int i=0;i<maxConexion;i++){
                existe023=existe023 || (conexiones0[i]==1 && conexiones1[i]==2);
                existe123=existe123 || (conexiones1[i]==1 && conexiones0[i]==2);
                existe045=existe045 || (conexiones0[i]==3 && conexiones1[i]==4);
                existe145=existe145 || (conexiones1[i]==3 && conexiones0[i]==4);
                existe077=existe077 || (conexiones0[i]==6 && conexiones1[i]==6);
            }
            b=((existe023 && existe123 && !existe045 && !existe145) || (uart==1 && existe023 && existe123 && existe045) || (uart==2 && existe023 && existe123 && existe145)) && existe077;
         }
         return b;
    }
    
    private int getXPin(int conector,int pin){
        int r=0;
        int x0=xConectores[conector];
        if(pin<14){
            r=x0+DISTANCIA_NUMERO_A_PIN;
        }
        else{
            r=x0+DISTANCIA_NUMERO_A_PIN+DISTANCIA_ENTRE_PINES;
        }
        return r;
    }
    
    private int getYPin(int conector,int pin){
        int r=0;
        int y0=yConectores[conector];
        if(pin<14){
            r=y0+pin*DISTANCIA_ENTRE_PINES;
        }
        else{
            r=y0+(pin-14)*DISTANCIA_ENTRE_PINES+DISTANCIA_ENTRE_PINES*3/2;
        }
        return r;
    }
    
    private int[] pinEnCoordenadas(int x,int y){
        int d[]=new int[2];
        d[0]=-1;
        d[1]=-1;
        boolean r=false;
        int conector;
        int pin;
        conector=0;
        int xc,yc;
       
        while(!r && conector<2){
            pin=0;
            while(!r && pin<25){
                xc=getXPin(conector,pin);
                yc=getYPin(conector,pin);
                r=(x<=xc+ANCHO_PIN && x>=xc && y<=yc+ANCHO_PIN && y>=yc);
                if(r){
                    d[0]=conector;
                    d[1]=pin;
                }
                pin++;
            }
            conector++;
        }
        return d;
    }
    
    private void dibujarConector(Graphics g,int x,int y,int n){
        xConectores[n]=x;
        yConectores[n]=y;
        int[] con;
        int pul;
        if(n==0){
            con=conexiones0;
            pul=pulsadoEn0;
        }
        else{
            con=conexiones1;
            pul=pulsadoEn1;
        }
        int i,j,k;
        for(i=0;i<13;i++){
            k=0;
            while(k<25 && con[k]!=i)k++;//-->>>>>
            if(k<25 || i==pul){
                g.fillArc(x+DISTANCIA_NUMERO_A_PIN, y+i*DISTANCIA_ENTRE_PINES, ANCHO_PIN, ANCHO_PIN,0,360);
            }
            else{
                g.drawArc(x+DISTANCIA_NUMERO_A_PIN, y+i*DISTANCIA_ENTRE_PINES, ANCHO_PIN, ANCHO_PIN,0,360);
            }
            g.drawString(String.valueOf(i+1), x, y+i*DISTANCIA_ENTRE_PINES+10);
            
        }
        for(j=13;j<25;j++){
            i=j-14;
            k=0;
            while(k<25 && con[k]!=j)k++;
            if(k<25 || j==pul){
                g.fillArc(x+DISTANCIA_NUMERO_A_PIN+DISTANCIA_ENTRE_PINES, y+i*DISTANCIA_ENTRE_PINES+DISTANCIA_ENTRE_PINES*3/2, ANCHO_PIN, ANCHO_PIN,0,360);
            }
            else{
                g.drawArc(x+DISTANCIA_NUMERO_A_PIN+DISTANCIA_ENTRE_PINES, y+i*DISTANCIA_ENTRE_PINES+DISTANCIA_ENTRE_PINES*3/2, ANCHO_PIN, ANCHO_PIN,0,360);
            }
            g.drawString(String.valueOf(j+1), x+2*DISTANCIA_NUMERO_A_PIN+DISTANCIA_ENTRE_PINES, y+i*DISTANCIA_ENTRE_PINES+DISTANCIA_ENTRE_PINES*3/2+10);
            
        }
    }
    
    private void eliminarConexion(int n){
        for(int i=n+1;i<conexiones0.length;i++){
            conexiones0[i-1]=conexiones0[i];
            conexiones1[i-1]=conexiones1[i];
        }
        maxConexion--;
    }
    
    public void setModo(boolean modo){
        this.modo=modo;
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                formMouseReleased(evt);
            }
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                formMousePressed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 357, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 408, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void formMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMousePressed
               
        
    }//GEN-LAST:event_formMousePressed

    private void formMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseReleased
        
    }//GEN-LAST:event_formMouseReleased

    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        int d[];
        int i;
        
        d=pinEnCoordenadas(evt.getX(),evt.getY());
        if(modo==CONECTANDO){
            if(d[0]!=-1){
                if(d[0]==0){
                    pulsadoEn0=d[1];
                }
                else{
                    pulsadoEn1=d[1];
                }
                if(pulsadoEn0!=-1 && pulsadoEn1!=-1){
                    boolean b=false;
                    for(i=0;i<maxConexion;i++){
                        b=b || (conexiones0[i]==pulsadoEn0 && conexiones1[i]==pulsadoEn1);
                    }
                    if(!b){
                        conexiones0[maxConexion]=pulsadoEn0;
                        conexiones1[maxConexion]=pulsadoEn1;
                        maxConexion++;
                    }
                    pulsadoEn0=-1;
                    pulsadoEn1=-1;
                }
            }
        }
        else{
            if(d[0]!=-1){
                if(d[0]==0){
                    boolean b=false;
                    for(i=0;i<maxConexion;i++){
                        b=conexiones0[i]==d[1];
                        if(b)break;
                    }
                    if(b){
                        eliminarConexion(i);
                    }
                }
                else{
                    boolean b=false;
                    for(i=0;i<maxConexion;i++){
                        b=conexiones1[i]==d[1];
                        if(b)break;
                    }
                    if(b){
                        eliminarConexion(i);
                    }
                }
                pulsadoEn0=-1;
                pulsadoEn1=-1;
            }
        }
        
        this.repaint();
        
    }//GEN-LAST:event_formMouseClicked
    
    public void desconectarTodo(){
        for(int i=0;i<conexiones0.length;i++){
            conexiones0[i]=-1;
            conexiones1[i]=-1;
        }
                maxConexion=0;
        this.repaint();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
